/*
 * Copyright (c) 2005-2007 Laf-Widget Kirill Grouchnikov. All Rights Reserved.
 *
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions are met:
 * 
 *  o Redistributions of source code must retain the above copyright notice, 
 *    this list of conditions and the following disclaimer. 
 *     
 *  o Redistributions in binary form must reproduce the above copyright notice, 
 *    this list of conditions and the following disclaimer in the documentation 
 *    and/or other materials provided with the distribution. 
 *     
 *  o Neither the name of Laf-Widget Kirill Grouchnikov nor the names of 
 *    its contributors may be used to endorse or promote products derived 
 *    from this software without specific prior written permission. 
 *     
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR 
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR 
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE 
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, 
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 
 */
package org.jvnet.lafwidget.list;

import javax.swing.*;

import org.jvnet.lafwidget.LafWidgetAdapter;
import org.jvnet.lafwidget.list.SmoothListDrop.DropSmoother;
import org.jvnet.lafwidget.list.SmoothListDrop.Listener;
import org.jvnet.lafwidget.utils.FadeConfigurationManager;
import org.jvnet.lafwidget.utils.FadeTracker.FadeKind;

/**
 * Widget that decorates lists with drag-and-drop support.
 * 
 * @author Kirill Grouchnikov
 */
public class ListDragAndDropWidget extends LafWidgetAdapter {
	/**
	 * The associated list.
	 */
	protected JList list;

	/**
	 * DnD listener.
	 */
	protected SmoothListDrop.Listener smoothDropListener;

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.jvnet.lafwidget.LafWidget#requiresCustomLafSupport()
	 */
	public boolean requiresCustomLafSupport() {
		return false;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.jvnet.lafwidget.LafWidgetAdapter#setComponent(javax.swing.JComponent)
	 */
	public void setComponent(JComponent jcomp) {
		super.setComponent(jcomp);
		this.list = (JList) jcomp;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.jvnet.lafwidget.LafWidgetAdapter#installListeners()
	 */
	@Override
	public void installListeners() {
		final ListModel listModel = this.list.getModel();
		if (listModel instanceof MutableListModel) {
			DropSmoother smoother = new DropSmoother(list) {
				@Override
				protected void move(int fromIndex, int toIndex) {
					((MutableListModel) listModel).move(fromIndex, toIndex);
					FadeConfigurationManager.getInstance().allowFades(
							FadeKind.ROLLOVER, list);
					list.revalidate();
					list.repaint();
				}

				@Override
				protected void init(int index) {
					FadeConfigurationManager.getInstance().disallowFades(
							FadeKind.ROLLOVER, list);
				}
			};
			this.smoothDropListener = new Listener(smoother);
			this.list.addMouseListener(this.smoothDropListener);
			this.list.addMouseMotionListener(this.smoothDropListener);
		}
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.jvnet.lafwidget.LafWidgetAdapter#uninstallListeners()
	 */
	@Override
	public void uninstallListeners() {
		if (this.smoothDropListener != null) {
			this.list.removeMouseListener(this.smoothDropListener);
			this.list.removeMouseMotionListener(this.smoothDropListener);

			this.smoothDropListener.stop();
			this.smoothDropListener = null;
		}
	}

}
